* Copyright (c) 1990 by AT&T Bell Telephone Laboratories, Incorporated. */
* The C++ Answer Book */
* Tony Hansen */
* All rights reserved. */
include <process.h>
include <debug.h>	/* DELETE */

define prprocess(p)								\
do {									\
out << "\t\t" << p << "\n";						\
out << "\t\t\tt_curstate == " << ps_print(p->t_curstate) << "\n";	\
out << "\t\t\tt_result == " << p->t_result << "\n";			\
out << "\t\t\tt_desiredtime == " << p->t_desiredtime << "\n";		\
} while(0)

oid process::dumpall(ostream &out)

   out << "process::dumpall()\n";
   out << "\tt_curtime == " << t_curtime << "\n";
   out << "\tt_thisprocess:\n";
   prprocess(t_thisprocess);

   out << "\twait processes:\n";
   for (process *p = t_waitprocesses; p; p = p->t_next)
prprocess(p);

   out << "\trun processes:\n";
   for (p = t_runprocesses; p; p = p->t_next)
prprocess(p);

   out << "\tdone processes:\n";
   for (p = t_doneprocesses; p; p = p->t_next)
prprocess(p);

