* Copyright (c) 1990 by AT&T Bell Telephone Laboratories, Incorporated. */
* The C++ Answer Book */
* Tony Hansen */
* All rights reserved. */
include <process.h>
include <debug.h>	/* DELETE */
/ remove a process from this object's memory
oid process_object::forget(process *tp)

   if (debug) /*DELETE*/ cerr << "process_object" << this << "::forget(" << tp << ")\n";

   if (!po_link)
return;

   for (process_link **lp = &po_link; *lp; )
if ((*lp)->pl_process == tp)
    {
    process_link *sv = *lp;
    *lp = sv->pl_next;
    delete sv;
    }

else
    lp = &(*lp)->pl_next;
   if (debug) /*DELETE*/ cerr << "<<<< process_object::forget(" << tp << ")\n";

