* Copyright (c) 1990 by AT&T Bell Telephone Laboratories, Incorporated. */
* The C++ Answer Book */
* Tony Hansen */
* All rights reserved. */
include <process.h>
include <debug.h>	/* DELETE */
/ Change
/	old_queue_head  --  old_queue  --  old_queue_tail
/ into
/	old_queue_head  --  old_queue  --  new_queue_tail
/			    new_queue  --  old_queue_tail
/ where old_queue_tail == this
/ Return new_queue_tail.
ueue_tail *queue_tail::cut()

   if (debug) /*DELETE*/ cerr << "queue_tail" << this << "::cut()\n";
   process_queue *oldQ = qt_queue;
   queue_tail *new_tail = new queue_tail(qt_mode, oldQ->q_max);
   process_queue *newQ = new_tail->qt_queue;

   // put the new tail on the old queue
   new_tail->qt_queue = oldQ;
   oldQ->q_tail = new_tail;

   // put the old tail on the new queue
   newQ->q_tail = this;
   qt_queue = newQ;

   if (debug) /*DELETE*/ cerr << "<<<< queue_tail" << this << "::cut() <- " << new_tail << "\n";
   return new_tail;

